import 'package:flutter/material.dart';

class customCardList3Widget extends StatefulWidget {
  @required var cards;
  @required var cardColumnCount;
  @required Function callback;

  customCardList3Widget({this.cards, this.cardColumnCount, this.callback});

  @override
  State<customCardList3Widget> createState() => _customCardList3WidgetState();
}

class _customCardList3WidgetState extends State<customCardList3Widget> {
  TextEditingController _textEditingController = TextEditingController();

  List<Widget> cards;

  @override
  void initState() {
    super.initState();
    cards = widget.cards;
  }

  @override
  Widget build(BuildContext context) {
    return Expanded(
      child: Column(
        children: [
          Padding(
            padding: EdgeInsets.fromLTRB(10, 10, 10, 10),
            child: SizedBox(
                height: (MediaQuery.of(context).size.height) * 0.1,
                child: TextField(
                  controller: _textEditingController,
                  onChanged: (content){
                    if(_textEditingController.text.trim() != null){
                      var res = widget.callback(_textEditingController.text.trim());
                      setState(() {
                        cards = res;
                      });
                    }
                  },
                  decoration: InputDecoration(
                    hintText: "Search ...",
                    suffixIcon: IconButton(
                      icon: Icon(
                          Icons.clear,
                        color: Colors.redAccent.shade400,
                      ),
                      onPressed: (){
                        if (_textEditingController.text.trim() != null) {
                        _textEditingController.clear();
                        setState(() {
                          cards = widget.cards;
                        });
                        }
                      },
                    ),
                    border: OutlineInputBorder(
                      borderRadius: BorderRadius.circular(20.0),
                    ),
                  ),
                ),
            ),
          ),
          SizedBox(
            height: (MediaQuery.of(context).size.height) * 0.9,
            child: GridView.count(
              scrollDirection: Axis.vertical,
              crossAxisCount:
              int.parse(widget.cardColumnCount),
              physics: ScrollPhysics(),
              shrinkWrap: true,
              children: cards,
            ),
          ),
        ],
      ),
    );
  }
}
