import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

class CustomImageTextCard extends StatelessWidget {
  final CustomImageTextCardParams customImageTextCardParams;
  // final Function() onPressed;
  // final Color containerColor;
  // final double height;
  // final double width;
  // final bool cardReverse;
  // final String cardIcon;
  // final double iconHeight;
  // final double iconWidth;
  // final double borderRadius;
  // final double containerShadowOpacity;

  // final double cardPadding;

  // final String cardTitle;
  // final TextAlign cardTitleAlign;
  // final double titleFontSize;
  // final FontWeight titleFontWeight;
  // final Color titleColor;

  // final String cardDesc;
  // final TextAlign cardDescAlign;
  // final double descFontSize;
  // final FontWeight descFontWeight;
  // final Color descColor;
  // final double descPadding;

  const CustomImageTextCard({Key key, this.customImageTextCardParams
      // this.onPressed,
      // this.containerColor,
      // this.height,
      // this.width,
      // this.cardIcon,
      // this.borderRadius,
      // this.containerShadowOpacity,
      // this.iconHeight,
      // this.iconWidth,
      // this.cardTitle,
      // this.cardTitleAlign,
      // this.titleFontSize,
      // this.titleFontWeight,
      // this.titleColor,
      // this.cardDesc,
      // this.cardDescAlign,
      // this.descFontSize,
      // this.descFontWeight,
      // this.descColor,
      // this.cardPadding,
      // this.cardReverse,
      // this.descPadding
      })
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    List<Widget> children = [
      if (customImageTextCardParams?.cardIcon.length > 0)
        Expanded(
          flex: 5,
          child: Image.network(
            customImageTextCardParams?.cardIcon,
            height: customImageTextCardParams.iconHeight ?? 70,
            width: customImageTextCardParams.iconWidth ?? 60,
            fit: BoxFit.contain,
          ),
        ),
      if (customImageTextCardParams?.cardTitle != null)
        SizedBox(
          width: double.maxFinite,
          child: Text(
            customImageTextCardParams.cardTitle,
            textAlign:
                customImageTextCardParams?.cardTitleAlign ?? TextAlign.center,
            style: TextStyle(
                fontSize: customImageTextCardParams.titleFontSize ?? 20,
                fontWeight: customImageTextCardParams.titleFontWeight,
                color: customImageTextCardParams.titleColor ?? Colors.black,
                letterSpacing: 1),
          ),
        ),
      if (customImageTextCardParams?.cardDesc != null)
        SizedBox(
            width: double.maxFinite,
            child: Padding(
              padding:
                  EdgeInsets.all(customImageTextCardParams.descPadding ?? 0),
              child: Text(
                customImageTextCardParams.cardDesc,
                textAlign:
                    customImageTextCardParams.cardDescAlign ?? TextAlign.center,
                style: TextStyle(
                    fontSize: customImageTextCardParams.descFontSize ?? 10,
                    fontWeight: customImageTextCardParams.descFontWeight,
                    color: customImageTextCardParams.descColor ?? Colors.black,
                    letterSpacing: 1),
              ),
            ))
    ];
    if (customImageTextCardParams?.cardReverse == true) {
      children = children.reversed.toList();
    }
    return Center(
      child: Container(
          height: customImageTextCardParams?.height ?? 100,
          width: customImageTextCardParams?.width ?? 100,
          decoration: BoxDecoration(
            color: customImageTextCardParams?.containerColor ?? Colors.white,
            borderRadius: BorderRadius.circular(
                customImageTextCardParams?.borderRadius ?? 10.0),
            boxShadow: [
              BoxShadow(
                color: Colors.grey.withOpacity(
                    customImageTextCardParams?.containerShadowOpacity ?? 0.5),
                spreadRadius: 2,
                blurRadius: 4,
                offset: const Offset(0, 3),
              ),
            ],
          ),
          child: Padding(
            padding:
                EdgeInsets.all(customImageTextCardParams?.cardPadding ?? 0.0),
            child: Column(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: children),
          )),
    );
  }
}
