import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

import 'custom-widget-provider/custom-services.dart';

Widget buildCard(ImageTextCard cardParameters) {
  return Container(
      child: Padding(
        padding: EdgeInsets.only(left: cardParameters.cardPaddingLeft,top: cardParameters.cardPaddingTop,right: cardParameters.cardPaddingRight,bottom: cardParameters.cardPaddingBottom),
        child: Card(
            color: cardParameters.backgroundColor,
            shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.circular(cardParameters.borderRadius),
            ),
            elevation: cardParameters.elevation,
            shadowColor: cardParameters.shadowColor,
            child: Column(children: <Widget>[
              cardParameters.imagePath.isNotEmpty
                  ? Container(child: Image.network(cardParameters.imagePath))
                  : Container(),
              Container(
                child: Padding(
                  padding: EdgeInsets.all(cardParameters.textPadding),
                  child: cardParameters.text == null ? Container() : Column(children: cardParameters.text),
                ),
              )
            ])),
      )
  );
}

Widget buildTextCard(CardText object) {
  return Padding(
      padding: const EdgeInsets.all(2),
      child: Align(
          alignment: Alignment.center,
          child: Row(children: [
            object.icon == null
                ? Container()
                : Padding(
                    padding: const EdgeInsets.only(right: 8.0),
                    child: Icon(object.icon, size: object.fontSize + 2, color: object.textColor),
                  ),
            Expanded(
                child: Wrap(children: [
              Text((object.label != null && object.label.isNotEmpty) ? object.label : "" + object.text,
                  softWrap: true,
                  style: TextStyle(
                    fontFamily: object.fontFamily,
                      fontSize: object.fontSize, color: object.textColor,))
            ]))
          ])));
}
